/*****************************************************************************
 *                                                                           *
 * PIC-232 - Comunicazione seriale per gestione memoria EEPROM 877 System    *
 * Copyright (C) 2009  by Walter Lain <kcswalter@member.fsf.org>             *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify      *
 * it under the terms of the GNU General Public License as published by      *
 * the Free Software Foundation; either version 3 of the License, or         *
 * (at your option) any later version.                                       *
 *                                                                           *
 * This program is distributed in the hope that it will be useful,           *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 * GNU General Public License for more details.                              *
 *                                                                           *
 * You should have received a copy of the GNU General Public License         *
 * along with this program; if not, write to the Free Software               *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *                                                                           *
 *****************************************************************************/

#include "params.h"			//definizioni programma


/********************************
 *         RELEASE NOTES        *
 ********************************
20110109 - rev. 1.2(c)
Modificata struttura del codice seriale, rimuovendo le funzioni grafiche dalle sub e portandole nel file graph.c.
 Aggiunti messaggi di ritorno dalle sub per gestione errori esterna.
 Leggera modifica sulla schermata di info per andare a capo sul primo spazio disponibile. Non e' ancora perfetta,
 perche' quando si usa PGUP e PGDN le righe si sfalsano, ma e' meglio di prima.
 
20100319 - rev. 1.2(b)
Modalita' parametrica da shell funzionante. Modificata allocazione dei vettori ee, eesize, memfile,
 che finalmente e' dinamica e varia in base alle impostazioni del programma

20100316 - rev. 1.2(a)
Aggiunta modalita' parametrica da shell - Work In Progress

20091231 - rev. 1.1(c)
Modificato tutto il programma in modo da gestire la localizzazione.
 La cosa non e' perfetta, tuttavia funziona adeguatamente.

20091229 - rev. 1.1(b)
Ridefinizione delle variabili comuni all'interno di un'unica struttura dati.
TODO: sarebbe bello gestire in modo "piu' dinamico" l'allocazione di ee,eemod,memfile,port,ports, ma
 non ho ben chiaro come si potrebbe fare. realloc() non funziona su parti di una struttura, ma
 sull'intero blocco (almeno cosi' ho letto, e d'altra parte dati->ee=realloc(dati->ee,size_t) non
 funziona.

20091228 - rev. 1.1(a)
Suddivisi i sorgenti in blocchi funzionali. Sistemato bug segfault in apertura files (se file non esiste
 non devo fare fclose(file) ne free(buffer) prima di uscire).
Sistemati un po' i commenti (sono ancora un indecenza, ma meglio di prima).
Compilare con:
gcc -O2 -lncurses -lm -Wall graph.c eeprom.c file.c serial.c sys.c PIC-232_lin-curses.c -o PIC-232

20091227 - rev. 1.0(h)
Rimosse variabili globali e inserita allocazione dinamica di alcune variabili.
Migliorata la lettura dei parametri dal file di configurazione.

20091226 - rev. 1.0(g)
La porta seriale ora viene aperta solo all'interno delle 3 sub di gestione, e chiusa subito dopo l'uso.
Convertito tutto il programma da C++ a C, rimossa libreria C++ "string" sostituendo string.length()
 con strlen(char *) e string.find("") con strstr(char *,"").
Rimossa libreria C++ iostream (utilizzata durante debug).
Rimossa libreria C++ fstream sostituendo fstream con FILE, fstream.open() con fopen(FILE), fstream.put()
 con fwrite(), fstream.get() con fread(), fstream.getline() con fscanf(), fstream<< con fprintf() e 
 fstream.close() con fclose(FILE).
Per compilare ora va usato: gcc -O2 -lncurses -lm PIC-232_lin-curses.c -o PIC-232

20091224 - rev. 1.0(f)
Aggiornata l'interfaccia curses per ridimensionamento shell, aggiunte alcune stupidate grafiche.

20091222 - rev. 1.0(e)
Piccole modifiche all'enumerazione delle porte seriali.

20091124 - rev. 1.0(d)
Modificato il cursore in editing carattere.
Riposizionato il cursore in editing numerico.
Nascosto cursore dove non serve (quasi ovunque).

20091123 - rev. 1.0(c)
Interfaccia con ncurses completata.

20091123 - rev. 1.0(b)
Alcuni miglioramenti dell'interfaccia con ncurses.

20091123 - rev. 1.0(a)
Aggiunti controlli sulla dimensione EEPROM nella gestione FILE. Prima release "ufficiale".
Ricordarsi di compilare con le opzioni -O2 e -lncurses.

20091123 - rev. 0.9(a)
Mi sono svegliato ed ho modificato TUTTO il codice per usare ncurses. La gestione dei tasti
 funzione adesso e' perfettamente a posto.
Sono da aggiungere solamente i controlli sulla dimensione EEPROM nella gestione FILE.

20091121 - rev. 0.8(c)
Aggiunta la parte di editing in modalita' numerica e la gestione pagine in editing carattere.
Occorre sempre aggiungere i controlli sulla dimensione EEPROM nella gestione FILE per evitare
 casini, e sistemare meglio la gestione dei tasti speciali che con mygetch() generano quello
 schifoso treno di codici di lunghezza variabile.

20091120 - rev. 0.8(b)
Sistemata la gestione scrittura con indirizzi di memoria a due bytes.
Aggiunti controlli sulla dimensione della EEPROM nelle sub di lettura e scrittura (dipendono
 anche dal software presente nel micro, che deve rispondere correttamente e terminare
 la trasmissione dati con apposito ack.
Mancano ancora la parte di editing in modalita' numerica e la gestione pagine in
editing carattere.
Occorre sempre aggiungere i controlli sulla dimensione EEPROM nella gestione FILE per evitare
 casini, e sistemare meglio la gestione dei tasti speciali che con mygetch() generano quello
 schifoso treno di codici di lunghezza variabile.


20091119 - rev. 0.8(a)
N.B.B.B.B.B.B.: LA MODALITA' SCRITTURA MANCA DELLA GESTIONE DI INDIRIZZI DI MEMORIA A 2 BYTES
Il programma e' abbastanza completo nelle sue funzionalita'. Manca praticamente solo la parte
 di editing in modalita' numerica e la gestione pagine in editing carattere.
 Occorre pero' aggiungere dei controlli sulla dimensione EEPROM/FILE per evitare casini, e
 sarebbe bene sistemare meglio la gestione dei tasti speciali che con mygetch() generano uno
 schifoso treno di codici di lunghezza variabile (perche' non si puo' usare bioskey()? Era
 cosi' funzionale... - E perche' sti stronzi hanno deciso che la codifica dei codici tastiera 
 e' a lunghezza variabile???).
Ho deciso che finche' TUTTE queste cose non saranno sistemate, il programma non passera'
 alla revisione 1.0.

*/

/********************************
 *          main program        *
 ********************************

Variabili interne:

- struttura SYSDATA:
ee[]=mappa memoria eeprom
eedata=modalita' gestione memoria (n=integer,c=character)
eemod[]=mappa celle EEPROM modificate
eemode=modalita' scrittura memoria (m=modifica,o=overwrite)
eesize=dimensioni memoria EEPROM
memfile[]=nome file memoria
port[]=indirizzo porta seriale in uso
portcount=numero porte seriali trovate
ports[]=elenco porte seriali trovate
serPort=oggetto porta seriale
speed=velocita' porta seriale

- altre:
stato=variabile per loop menu principale (0=loop, 1=esci)
*/
int main(int argc, char *argv[])
{
   SYSTEXT strings;			//init struttura messaggi
   SYSDATA dati;			//init struttura dati
   dati.eedata='c';					//modalita' gestione memoria (n=integer,c=character)
   dati.eemode='m';					//modalita' scrittura memoria (m=modifica,o=overwrite)
   dati.eesize=0;					//dimensioni memoria EEPROM
   dati.portcount=0;					//numero porte seriali trovate
   dati.serPort=0;					//oggetto porta seriale
   dati.speed=0;					//velocita' porta seriale
   dati.ee=(char*)calloc(sizeof(char),1);		//mappa memoria EEPROM
   dati.eemod=(bool*)calloc(sizeof(bool),1);		//mappa celle EEPROM modificate
   dati.memfile=(char*)calloc(sizeof(char),1);		//nome file memoria
   dati.port=(char*)calloc(sizeof(char),maxport);	//indirizzo porta seriale in uso
   dati.ports=(char*)calloc(sizeof(char)*maxport,64);	//elenco porte seriali trovate
   int stato;
   if(argc>1)				//verifica se chiamato con argomenti
   {
     dati.cmdline=true;			//si, modalita' parametrica
   }
   else
   {
     dati.cmdline=false;		//no, modalita' "grafica"
   }
   signal(SIGINT, chiudi);		// termina al segnale di interruzione

   if(dati.cmdline)			//modalita' parametrica
   {
     int cnt, mode=0;			//cnt=contatore per recupero parametri, mode=modo programma
     int tmpaddr=0,tmpdata=0;		//buffer dati
     system("clear");
     dati.portcount=1;			//salta enumerazione porte seriali, assume porta dichiarata valida
     if(readlocal(dati.cmdline,&strings))	//carica localizzazione
     {
       //se non trova il file, termina il programma
       return 1;
     }
     splash(dati.cmdline,&strings);	//messaggio iniziale
     if(argc==2)
     {
       if(strcmp(argv[1],"-?")==0)	//richiesta help?
       {
	 help(&dati);			//si
       }
       else if(strcmp(argv[1],"-v")==0)	//richiesta versione?
       {
	 printf("Program Version: %i.%i\n",rev1,rev2);	//si
	 printf(" Build: %c\n",rev3);
	 if(date<1000)
	   printf(" Release date: %i0%i\n\n",year,date);	//mesi da 1 a 9
	 else
	   printf(" Release date: %i%i\n\n",year,date);		//mesi da 10 a 12
       }
       else				//no, solo 1 parametro, errore
       {
	 printf("ERROR: TOO FEW ARGUMENTS\n\n");
	 help(&dati);			//visualizza help
       }
     }
     else
     {
        cnt=1;
        do
        {
	  if(strcmp(argv[cnt],"-r")==0)
	  {
	    if(DEBUG)
	      printf("Read all EEPROM to stdout\n");
	    if(argc!=8)			//mumero di argomenti sbagliato
	    {
	      printf("WRONG ARGUMENTS NUMBER - Needed 7, got %i.\n\n",argc-1);
	    }
	    else
	      mode=1;			//imposta modo programma
	  }
	  //attualmente non puo' funzionare, occorre aggiungere firmware al micro
/*	  else if(strcmp(argv[cnt],"-rc")==0)
	  {
	    printf("Read EEPROM cell to stdout\n");
	    if(argc!=8)			//mumero di argomenti sbagliato
	    {
	      printf("WRONG ARGUMENTS NUMBER - Needed 7, got %i.\n\n",argc-1);
	    }
	    else
	      mode=2;			//imposta modo programma
	  }*/
	  else if(strcmp(argv[cnt],"-rf")==0)
	  {
	    if(DEBUG)
	      printf("Read all EEPROM to file\n");
	    if(argc!=10)		//mumero di argomenti sbagliato
	    {
	      printf("WRONG ARGUMENTS NUMBER - Needed 9, got %i.\n\n",argc-1);
	    }
	    else
	      mode=3;			//imposta modo programma
	  }
	  else if(strcmp(argv[cnt],"-wc")==0)
	  {
	    if(DEBUG)
	      printf("Write EEPROM cell\n");
	    if(argc!=10)		//mumero di argomenti sbagliato
	    {
	      printf("WRONG ARGUMENTS NUMBER - Needed 9, got %i.\n\n",argc-1);
	    }
	    else
	      mode=4;			//imposta modo programma
	  }
	  else if(strcmp(argv[cnt],"-wf")==0)
	  {
	    if(DEBUG)
	      printf("Write all EEPROM from file\n");
	    if(argc!=10)		//mumero di argomenti sbagliato
	    {
	      printf("WRONG ARGUMENTS NUMBER - Needed 9, got %i.\n\n",argc-1);
	    }
	    else
	      mode=5;			//imposta modo programma
	  }
	  else if(strcmp(argv[cnt],"-ping")==0)
	  {
	    if(DEBUG)
	      printf("Communication test\n");
	    if(argc!=6)			//mumero di argomenti sbagliato
	    {
	      printf("WRONG ARGUMENTS NUMBER - Needed 5, got %i.\n\n",argc-1);
	    }
	    else
	      mode=6;			//imposta modo programma
	  }
	  else if(strcmp(argv[cnt],"-p")==0)
	  {
	    cnt++;
	    if(strncmp(argv[cnt],"-",1)==0)
	    {
	      mode=0;			//imposta modo programma - errore
	      printf("WRONG ARGUMENT SYNTAX - Serial Port.\n\n");
	      break;
	    }
	    else
	    {
	      strcpy(dati.port,argv[cnt]);
	      if(DEBUG)
		printf("Serial port: %s\n",dati.port);
	    }
	  }
	  else if(strcmp(argv[cnt],"-s")==0)
	  {
	    cnt++;
	    if(strncmp(argv[cnt],"-",1)==0)
	    {
	      mode=0;			//imposta modo programma - errore
	      printf("WRONG ARGUMENT SYNTAX - EEPROM size.\n\n");
	      break;
	    }
	    else
	    {
	      dati.eesize=atoi(argv[cnt]);
	      if(dati.ee!=NULL)
		free(dati.ee);
	      if(dati.eemod!=NULL)
		free(dati.eemod);
	      dati.ee=(char*)calloc(sizeof(char),dati.eesize);	//rialloca la giusta dimensione
	      dati.eemod=(bool*)calloc(sizeof(bool),dati.eesize);
	      if(DEBUG)
		printf("EEPROM size: %i\n",dati.eesize);
	    }
	  }
	  else if(strcmp(argv[cnt],"-a")==0)
	  {
	    cnt++;
	    if(strncmp(argv[cnt],"-",1)==0)
	    {
	      mode=0;			//imposta modo programma - errore
	      printf("WRONG ARGUMENT SYNTAX - Cell address.\n\n");
	      break;
	    }
	    else
	    {
	      tmpaddr=atoi(argv[cnt]);
	      if(DEBUG)
		printf("Cell address: %i\n",tmpaddr);
	    }
	  }
	  else if(strcmp(argv[cnt],"-v")==0)
	  {
	    cnt++;
	    if(strncmp(argv[cnt],"-",1)==0)
	    {
	      mode=0;			//imposta modo programma - errore
	      printf("WRONG ARGUMENT SYNTAX - Serial port speed.\n\n");
	      break;
	    }
	    else
	    {
	      dati.speed=atoi(argv[cnt]);
	      if(DEBUG)
		printf("Serial port speed: %i\n",dati.speed);
	    }
	  }
	  else if(strcmp(argv[cnt],"-d")==0)
	  {
	    cnt++;
	    if(strncmp(argv[cnt],"-",1)==0)
	    {
	      mode=0;			//imposta modo programma - errore
	      printf("WRONG ARGUMENT SYNTAX - Cell value.\n\n");
	      break;
	    }
	    else
	    {
	      tmpdata=atoi(argv[cnt]);
	      if(DEBUG)
		printf("Cell value: %i\n",tmpdata);
	    }
	  }
	  else if(strcmp(argv[cnt],"-f")==0)
	  {
	    cnt++;
	    if(strncmp(argv[cnt],"-",1)==0)
	    {
	      mode=0;			//imposta modo programma - errore
	      printf("WRONG ARGUMENT SYNTAX - EEPROM file.\n\n");
	      break;
	    }
	    else
	    {
	      if(dati.memfile!=NULL)
		free(dati.memfile);
	      dati.memfile=(char*)calloc(sizeof(char),strlen(argv[cnt])+1);	//rialloca la giusta dimensione
	      strcpy(dati.memfile,argv[cnt]);
	      if(DEBUG)
		printf("EEPROM file: %s\n",dati.memfile);
	    }
	  }
	  cnt++;
	}while(cnt<argc&&mode!=0);
        switch(mode)
	{
	  case 0:			//si trova qui solo se c'e un errore nei parametri
	  {
	    help(&dati);		//visualizza help
	    break;
	  }
	  case 1:			//Read all EEPROM to stdout
	  {
	    e2read(&dati,&strings,1);	//legge EEPROM
	    break;
	  }
	  //attualmente non puo' funzionare, occorre aggiungere firmware al micro
/*	  case 2:			//Read EEPROM cell to stdout
	  {
	    e2read(&dati,&strings,1);	//legge EEPROM
	    break;
	  }*/
	  case 3:			//Read all EEPROM to file
	  {
	    e2read(&dati,&strings,0);	//legge EEPROM
	    e2save(&dati,&strings);	//salva su file
	    break;
	  }
	  case 4:			//Write EEPROM cell
	  {
	    for(stato=0;stato<dati.eesize;stato++)	//azzera dati
	    {
	      dati.ee[stato]=0;
	      dati.eemod[stato]=false;
	    }
	    dati.ee[tmpaddr]=tmpdata;	//imposta dato da scrivere
	    dati.eemod[tmpaddr]=true;	//imposta dato modificato
	    e2write(&dati,&strings);	//scrive EEPROM
	    break;
	  }
	  case 5:			//Write all EEPROM from file
	  {
	    stato=e2load(&dati,&strings);	//carica dati
	    if(stato==0)
	      e2write(&dati,&strings);	//scrive EEPROM
	    break;
	  }
	  case 6:			//Communication test
	  {
	    ping(&dati,&strings);	//ping
	    break;
	  }
	  default:
	  {
	    break;
	  }
	}
     }
   }
   else					//modalita' grafica
   {
     initscr();      			// inizializza la libreria curses
     keypad(stdscr, TRUE);  		// abilita la mappatura della tastiera
     nonl();         			// non convertire NL->CR/NL in output
     cbreak();       			// prende i caratteri in input uno alla volta, senza attendere il \n
     noecho();       			// nessuna echo dell'input
     dati.portcount=serenum(&dati);	//enumerazione porte seriali
     if(readlocal(dati.cmdline,&strings))	//carica localizzazione
     {
       clear();				//se non trova il file, termina il programma
       endwin();				//chiusura ncurses
       system("clear");			//pulisce terminale
       //pulizia memoria
       if(dati.ee!=NULL)
	 free(dati.ee);
       if(dati.eemod!=NULL)
	 free(dati.eemod);
       if(dati.memfile!=NULL)
	 free(dati.memfile);
       if(dati.port!=NULL)
	 free(dati.port);
       if(dati.ports!=NULL)
	 free(dati.ports);
       return 1;
     }
     splash(dati.cmdline,&strings);	//splash screen
     readcfg(&dati,&strings);		//carica file configurazione
     //rialloca la memoria
     if(dati.ee!=NULL)
       free(dati.ee);
     if(dati.eemod!=NULL)
       free(dati.eemod);
     dati.ee=(char*)calloc(sizeof(char),dati.eesize);	//rialloca la giusta dimensione
     dati.eemod=(bool*)calloc(sizeof(bool),dati.eesize);
     for(stato=0;stato<dati.eesize;stato++)
     {
       dati.ee[stato]=0;
       dati.eemod[stato]=true;
     }
     if(!fileexists(dati.port))		//verifica se la porta default esiste
     {
       seropenerr(&dati,&strings);	//visualizza errore
     }
     stato=0;
     while(stato==0)			//cicla finche' non si esce dal programma
     {
       stato=menu(&dati,&strings);
     }
     clear();
     endwin();				//chiusura ncurses
   }
   //pulizia memoria
   if(dati.ee!=NULL)
     free(dati.ee);
   if(dati.eemod!=NULL)
     free(dati.eemod);
   if(dati.memfile!=NULL)
     free(dati.memfile);
   if(dati.port!=NULL)
     free(dati.port);
   if(dati.ports!=NULL)
     free(dati.ports);
   if(strings.eesize001!=NULL)
     free(strings.eesize001);
   if(strings.eesize002!=NULL)
     free(strings.eesize002);
   if(strings.eesize003!=NULL)
     free(strings.eesize003);
   if(strings.eesize004!=NULL)
     free(strings.eesize004);
   if(strings.eesize005!=NULL)
     free(strings.eesize005);
   if(strings.eesize006!=NULL)
     free(strings.eesize006);
   if(strings.eesize007!=NULL)
     free(strings.eesize007);
   if(strings.err001!=NULL)
     free(strings.err001);
   if(strings.err002!=NULL)
     free(strings.err002);
   if(strings.err003!=NULL)
     free(strings.err003);
   if(strings.err004!=NULL)
     free(strings.err004);
   if(strings.err005!=NULL)
     free(strings.err005);
   if(strings.err006!=NULL)
     free(strings.err006);
   if(strings.header001!=NULL)
     free(strings.header001);
   if(strings.header002!=NULL)
     free(strings.header002);
   if(strings.header003!=NULL)
     free(strings.header003);
   if(strings.header004!=NULL)
     free(strings.header004);
   if(strings.header005!=NULL)
     free(strings.header005);
   if(strings.header006!=NULL)
     free(strings.header006);
   if(strings.header007!=NULL)
     free(strings.header007);
   if(strings.info001!=NULL)
     free(strings.info001);
   if(strings.menu001!=NULL)
     free(strings.menu001);
   if(strings.menu002!=NULL)
     free(strings.menu002);
   if(strings.menu003!=NULL)
     free(strings.menu003);
   if(strings.menu004!=NULL)
     free(strings.menu004);
   if(strings.menu005!=NULL)
     free(strings.menu005);
   if(strings.menu006!=NULL)
     free(strings.menu006);
   if(strings.menu007!=NULL)
     free(strings.menu007);
   if(strings.menu008!=NULL)
     free(strings.menu008);
   if(strings.menu009!=NULL)
     free(strings.menu009);
   if(strings.menu010!=NULL)
     free(strings.menu010);
   if(strings.menu020!=NULL)
     free(strings.menu020);
   if(strings.menu021!=NULL)
     free(strings.menu021);
   if(strings.menu022!=NULL)
     free(strings.menu022);
   if(strings.menu023!=NULL)
     free(strings.menu023);
   if(strings.menu024!=NULL)
     free(strings.menu024);
   if(strings.menu025!=NULL)
     free(strings.menu025);
   if(strings.menu030!=NULL)
     free(strings.menu030);
   if(strings.menu031!=NULL)
     free(strings.menu031);
   if(strings.menu032!=NULL)
     free(strings.menu032);
   if(strings.menu040!=NULL)
     free(strings.menu040);
   if(strings.menu041!=NULL)
     free(strings.menu041);
   if(strings.menu042!=NULL)
     free(strings.menu042);
   if(strings.menu043!=NULL)
     free(strings.menu043);
   if(strings.menu050!=NULL)
     free(strings.menu050);
   if(strings.menu051!=NULL)
     free(strings.menu051);
   if(strings.overwrite001!=NULL)
     free(strings.overwrite001);
   if(strings.overwrite002!=NULL)
     free(strings.overwrite002);
   if(strings.overwrite003!=NULL)
     free(strings.overwrite003);
   if(strings.overwrite004!=NULL)
     free(strings.overwrite004);
   if(strings.overwrite005!=NULL)
     free(strings.overwrite005);
   if(strings.overwrite006!=NULL)
     free(strings.overwrite006);
   if(strings.overwrite007!=NULL)
     free(strings.overwrite007);
   if(strings.overwrite008!=NULL)
     free(strings.overwrite008);
   if(strings.pgupdown001!=NULL)
     free(strings.pgupdown001);
   if(strings.setchk001!=NULL)
     free(strings.setchk001);
   if(strings.setchk002!=NULL)
     free(strings.setchk002);
   if(strings.splash001!=NULL)
     free(strings.splash001);
   if(strings.str001!=NULL)
     free(strings.str001);
   if(strings.str002!=NULL)
     free(strings.str002);
   if(strings.str003!=NULL)
     free(strings.str003);
   if(strings.str004!=NULL)
     free(strings.str004);
   if(strings.str005!=NULL)
     free(strings.str005);
   if(strings.str006!=NULL)
     free(strings.str006);
   if(strings.str007!=NULL)
     free(strings.str007);
   if(strings.str008!=NULL)
     free(strings.str008);
   if(strings.str009!=NULL)
     free(strings.str009);
   if(strings.str010!=NULL)
     free(strings.str010);
   if(strings.str011!=NULL)
     free(strings.str011);
   if(strings.str012!=NULL)
     free(strings.str012);
   if(strings.str013!=NULL)
     free(strings.str013);
   if(strings.str014!=NULL)
     free(strings.str014);
   if(strings.str015!=NULL)
     free(strings.str015);
   if(strings.str016!=NULL)
     free(strings.str016);
   if(strings.str017!=NULL)
     free(strings.str017);
   if(strings.str018!=NULL)
     free(strings.str018);
   if(strings.str019!=NULL)
     free(strings.str019);
   if(strings.str020!=NULL)
     free(strings.str020);
   if(strings.strike001!=NULL)
     free(strings.strike001);
   if(strings.success001!=NULL)
     free(strings.success001);
   if(strings.success002!=NULL)
     free(strings.success002);
   if(strings.success003!=NULL)
     free(strings.success003);
   if(strings.success004!=NULL)
     free(strings.success004);
   if(strings.success005!=NULL)
     free(strings.success005);
   if(strings.success006!=NULL)
     free(strings.success006);
   if(strings.sure001!=NULL)
     free(strings.sure001);
   return 0;
}
